with CSSW_COMMON_TYPES;   use CSSW_COMMON_TYPES;
with IASW_COMMON;
with IASW_BUFFER;

package IASW_EVSORT is

   package CCT renames CSSW_COMMON_TYPES;

   -- The maximal amount of events that can be sorted at once.
   MAX_AMOUNT_OF_EVENTS_TO_SORT : constant IASW_BUFFER.T_BUFFER_INDEX := 2600;

   subtype T_POSITION_KEY is CCT.T_UNSIGNED_16;


   --------------------------------------------------------------------
   -- Local types and data, made global because of possible patching --
   --------------------------------------------------------------------

   -- Table of indices showing the order of events.

   type T_SORT_DATA is
      record
         BUFFER_POS : IASW_BUFFER.T_BUFFER_INDEX;
         KEY        : T_POSITION_KEY;
      end record;

   SORTED_EVENTS : array (IASW_BUFFER.T_BUFFER_INDEX
     range 0 .. MAX_AMOUNT_OF_EVENTS_TO_SORT - 1) of T_SORT_DATA;

   AMOUNT_OF_SORTED_EVENTS : IASW_BUFFER.T_BUFFER_INDEX;


   ----------------------------------------------------------------
   -- Local procedures, made global because of possible patching --
   ----------------------------------------------------------------

   procedure QSORT_EVENTS;


   -----------------------
   -- Global procedures --
   -----------------------

   procedure SORT_EVENTS;

   procedure PEEK_SORTED_EVENT (
      INDEX : in IASW_BUFFER.T_BUFFER_INDEX;
      EVENT : in out IASW_COMMON.T_EVENT);

   function GET_AMOUNT_OF_SORTED_EVENTS return IASW_BUFFER.T_BUFFER_INDEX;

   procedure CLEAR_SORTING_KEYS_LIST;

   procedure ADD_SORTING_KEY (
      BUFFER_POS : in IASW_BUFFER.T_BUFFER_INDEX;
      KEY        : in T_POSITION_KEY );

end IASW_EVSORT;
