with IASW_COMMON;
with IASW_DFEE;

package IASW_PATCHES is

   type T_PATCH_RETCODE is (
      PATCHES_OK,
      PATCHES_TABLE_FULL,
      PATCHES_LENGTH_ERROR,
      PATCHES_INDEX_ERROR
   );

   --------------------------------------------------------------------
   -- Local types and data, made global because of possible patching --
   --------------------------------------------------------------------

   K_MAX_DFEE_PATCHES : constant INTEGER := 150;

   type T_DFEE_PATCH is record
      HDR : IASW_DFEE.T_MEM_BLOCK_SPEC;
      MEM : IASW_DFEE.T_MEM_BLOCK(1..IASW_DFEE.K_MAX_LOAD_MEM_BLK_LEN);
   end record;

   NUMBER_DFEE_PATCHES : INTEGER;
   DFEE_PATCHES : array(1..K_MAX_DFEE_PATCHES) of T_DFEE_PATCH;


   -----------------------
   -- Global procedures --
   -----------------------

   procedure CLEAR;

   procedure ADD_PATCH(
      HDR  : in IASW_DFEE.T_MEM_BLOCK_SPEC;
      DATA : in IASW_DFEE.T_MEM_BLOCK;
      RETCODE : out T_PATCH_RETCODE
   );

   procedure GET_PATCH(
      NUM  : in INTEGER;
      HDR  : out IASW_DFEE.T_MEM_BLOCK_SPEC;
      DATA : out IASW_DFEE.T_MEM_BLOCK;
      RETCODE : out T_PATCH_RETCODE
   );

   function GET_NUM_PATCHES return INTEGER;

   procedure CONSTRUCTOR;

end IASW_PATCHES;
